#include "interface.h"
#include <qlayout.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qfiledialog.h>
#include <qmessagebox.h>

//using namespace qglviewer;

static const char* const image0_data[] = { 
// "Save" icon
"22 22 5 1",
". c None",
"# c #000000",
"a c #838100",
"b c #c5c2c5",
"c c #cdb6d5",
"......................",
".####################.",
".#aa#bbbbbbbbbbbb#bb#.",
".#aa#bbbbbbbbbbbb#bb#.",
".#aa#bbbbbbbbbcbb####.",
".#aa#bbbccbbbbbbb#aa#.",
".#aa#bbbccbbbbbbb#aa#.",
".#aa#bbbbbbbbbbbb#aa#.",
".#aa#bbbbbbbbbbbb#aa#.",
".#aa#bbbbbbbbbbbb#aa#.",
".#aa#bbbbbbbbbbbb#aa#.",
".#aaa############aaa#.",
".#aaaaaaaaaaaaaaaaaa#.",
".#aaaaaaaaaaaaaaaaaa#.",
".#aaa#############aa#.",
".#aaa#########bbb#aa#.",
".#aaa#########bbb#aa#.",
".#aaa#########bbb#aa#.",
".#aaa#########bbb#aa#.",
".#aaa#########bbb#aa#.",
"..##################..",
"......................"};


static const char* const image1_data[] = { 
// "Open" icon
"22 22 5 1",
". c None",
"# c #000000",
"c c #848200",
"a c #ffff00",
"b c #ffffff",
"......................",
"......................",
"......................",
"............####....#.",
"...........#....##.##.",
"..................###.",
".................####.",
".####...........#####.",
"#abab##########.......",
"#babababababab#.......",
"#ababababababa#.......",
"#babababababab#.......",
"#ababab###############",
"#babab##cccccccccccc##",
"#abab##cccccccccccc##.",
"#bab##cccccccccccc##..",
"#ab##cccccccccccc##...",
"#b##cccccccccccc##....",
"###cccccccccccc##.....",
"##cccccccccccc##......",
"###############.......",
"......................"};

static const char* const image2_data[] = { 
//"Undo" icon
"22 22 3 1",
". c None",
"# c #000084",
"a c #848284",
"......................",
"......................",
"......................",
"......................",
"......................",
"...........######a....",
"..#......##########...",
"..##...####......##a..",
"..###.###.........##..",
"..######..........##..",
"..#####...........##..",
"..######..........##..",
"..#######.........##..",
"..########.......##a..",
"...............a###...",
"...............###....",
"......................",
"......................",
"......................",
"......................",
"......................",
"......................"};

static const char* const image3_data[] = { 
// "Redo" icon
"22 22 3 1",
". c None",
"a c #000084",
"# c #848284",
"......................",
"......................",
"......................",
"......................",
"......................",
"....#aaaaaa...........",
"...aaaaaaaaaa......a..",
"..#aa......aaaa...aa..",
"..aa.........aaa.aaa..",
"..aa..........aaaaaa..",
"..aa...........aaaaa..",
"..aa..........aaaaaa..",
"..aa.........aaaaaaa..",
"..#aa.......aaaaaaaa..",
"...aaa#...............",
"....aaa...............",
"......................",
"......................",
"......................",
"......................",
"......................",
"......................"};

static const char* const image4_data[] = { 
// "Cut" icon
"22 22 3 1",
". c None",
"# c #000000",
"a c #000082",
"......................",
".......#.....#........",
".......#.....#........",
".......#.....#........",
".......#....##........",
".......##...#.........",
"........#...#.........",
"........##.##.........",
".........###..........",
".........###..........",
"..........#...........",
".........a#a..........",
"........aa.aaa........",
".......a.a.a..a.......",
"......a..a.a...a......",
".....a...a.a....a.....",
"....a....a.a....a.....",
"....a....a..a...a.....",
"....a....a..a..a......",
"....a...a....aa.......",
".....aaa..............",
"......................"};

static const char* const image5_data[] = { 
// "Copy" icon
"22 22 6 1",
". c None",
"# c #000000",
"b c #000082",
"c c #3c3cfd",
"d c #8b8bfd",
"a c #ffffff",
"......................",
"......................",
"########..............",
"#aaaaaa##.............",
"#a####a#a#............",
"#aaaaaa#aa#...........",
"#a####a#bbbbbbbb......",
"#aaaaaa#baaaaaabb.....",
"#a#####aba####abcb....",
"#aaaaaaabaaaaaabdcb...",
"#a#####aba####abadcb..",
"#aaaaaaabaaaaaabbbbbb.",
"#a#####aba####aaaaaab.",
"#aaaaaaabaaaaaaaaaaab.",
"#a#####aba#########ab.",
"#aaaaaaabaaaaaaaaaaab.",
"########ba#########ab.",
"........baaaaaaaaaaab.",
"........ba#########ab.",
"........baaaaaaaaaaab.",
"........bbbbbbbbbbbbb.",
"......................"};

static const char* const image6_data[] = { 
// "Paste" icon
"22 22 8 1",
". c None",
"# c #000000",
"e c #000084",
"c c #848200",
"b c #848284",
"d c #c6c3c6",
"a c #ffff00",
"f c #ffffff",
"......................",
".......#####..........",
"..######aaa######.....",
".######aaaaa######....",
"##bcb##a###a##bcb##...",
"#bcb#ddddddddd#bcb#...",
"#cbc#ddddddddd#cbc#...",
"#bcb###########bcb#...",
"#cbcbcbcbcbcbcbcbc#...",
"#bcbcbcbcbcbcbcbcb#...",
"#cbcbcbceeeeeeeeee#...",
"#bcbcbcbefffffffefe...",
"#cbcbcbcefeeeeefeffe..",
"#bcbcbcbefffffffefffe.",
"#cbcbcbcefeeeeefeffffe",
"#bcbcbcbefffffffeeeeee",
"#cbcbcbcefeeeeeffffffe",
"#bcbcbcbeffffffffffffe",
"#cbcbcbcefeeeeeeeeeefe",
".#######effffffffffffe",
"........eeeeeeeeeeeeee",
"......................"};

static const char* const image7_data[] = { 
// "What is... ?" icon
"22 22 106 2",
"Qt c None",
"#N c #212121",
"#J c #292929",
"#K c #393939",
"#M c #424242",
".m c #5a5a5a",
"#r c #5a736b",
"#A c #5a9c84",
"#B c #636363",
".N c #636b6b",
"#G c #63736b",
"#v c #63ad8c",
"#H c #6b6b6b",
".c c #6b7373",
"#D c #6b7b73",
".l c #6b7b7b",
".W c #6b847b",
".t c #6b8c7b",
"#x c #6b9484",
"#w c #6bad94",
".u c #737373",
".v c #737b73",
".g c #737b7b",
".D c #738c84",
".7 c #739484",
"#d c #73948c",
"#z c #73a59c",
"#p c #73b594",
"#o c #73bd9c",
".b c #7b7b7b",
".O c #7b8484",
"#a c #7bad94",
"#q c #7bad9c",
"#i c #7bb59c",
".5 c #7bbd9c",
"#b c #7bbda5",
"#h c #7bc69c",
"#y c #7bc6a5",
".8 c #848484",
".4 c #8484b5",
".h c #849c94",
"#n c #84a5ad",
".V c #84ada5",
"#E c #84b59c",
"#F c #84b5a5",
"#j c #84bda5",
"#t c #84c6a5",
"#l c #84cead",
".E c #8c8c8c",
"#g c #8c8cbd",
"## c #8c94b5",
"#m c #8cadbd",
"#c c #8cb5a5",
".L c #8cc6ad",
".T c #8ccead",
"#f c #8cceb5",
".a c #949494",
".n c #94a59c",
"#u c #94a5ce",
".k c #94bdad",
".M c #94c6ad",
".6 c #94c6b5",
".B c #94ceb5",
".1 c #94d6b5",
".C c #94d6bd",
".9 c #94debd",
".K c #9c94d6",
".d c #9c9c9c",
".w c #9cbdb5",
"#. c #9cbdd6",
"#s c #9ccebd",
".2 c #9ccece",
".0 c #9cdebd",
".S c #9ce7bd",
".Z c #9ce7c6",
".U c #a594de",
"#L c #a5a5a5",
".A c #a5b5de",
".3 c #a5b5ef",
".I c #a5cece",
"#k c #a5dec6",
".s c #a5e7c6",
".f c #adadad",
".J c #adadef",
".R c #adb5de",
".i c #adcec6",
".P c #add6c6",
".j c #addece",
"#e c #ade7ce",
".# c #b5b5b5",
".H c #b5bdde",
".Q c #b5dede",
".r c #b5efd6",
".e c #bdbdbd",
".z c #bdc6f7",
".y c #bdd6ff",
".X c #bde7d6",
".q c #bdefde",
".Y c #bdf7de",
"#I c #c6c6c6",
".x c #c6def7",
".p c #c6f7e7",
"#C c #ced6ce",
".G c #cedeff",
".o c #ceffef",
".F c #d6fff7",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQt.#.a.b.c.c.b.d.eQtQtQtQtQtQtQtQtQtQtQt",
"QtQt.f.g.h.i.j.j.k.l.b.#QtQtQtQtQtQtQtQtQtQt",
"Qt.f.m.n.o.o.p.q.r.s.t.u.eQtQtQtQtQtQtQtQtQt",
".e.v.w.q.p.x.y.z.A.B.C.D.EQtQtQtQtQtQtQtQtQt",
".d.h.F.q.G.H.I.I.J.K.L.M.N.#QtQtQtQtQtQtQtQt",
".O.P.o.Q.R.B.S.T.A.U.V.B.W.dQtQtQtQtQtQtQtQt",
".g.X.Y.Z.Z.0.1.2.3.4.5.6.7.8QtQtQtQtQtQtQtQt",
".g.j.r.0.9.1#..3###a#b#c#d.8QtQtQtQtQtQtQtQt",
".v.P#e.1.1#f.A#g.5#h#i#j.W.EQtQtQtQtQtQtQtQt",
".E#c#k#f.L#l#m#n#o#p#p#q#r.fQtQtQtQtQtQtQtQt",
".f.g#s#t#t#b#u.4#v#w#w#x.u.eQtQtQtQtQtQtQtQt",
"Qt.E.t#y#b.5#z#d#p#A#A#B.d#C.f.eQtQtQtQtQtQt",
"Qt.e.b#D#E#F#j#i#a.7.m.dQt.f#B.m.fQtQtQtQtQt",
"QtQt.e.E.N#D.W.W#G#H.fQtQt#I.b#J#K.E.eQtQtQt",
"QtQtQtQt.#.d.E.a#L#IQtQtQtQtQt#L#M#J#H.fQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt.e.u#N#K.aQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt.d#K#N#H",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt.##B.m",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt"};

static const char* const image8_data[] = { 
// "Exit" icon
"32 32 10 1",
". c None",
"e c None",
"f c None",
"h c None",
"b c #000000",
"a c #000000",
"# c #000000",
"c c #737573",
"d c #7b757b",
"g c #7b797b",
"................................",
"................................",
"................................",
"...............###..............",
"...............###.a............",
"...........b...###..............",
".........#.....###.....#........",
"........###....###....###.......",
".......#####...###...#####......",
"......c####d...###...d####c.....",
"......#####....###....#####.....",
".....#####..e..###....e#####....",
".....####......###......####....",
"....c####......###......####c...",
"....####.......###.......####...",
"....####.......###.......####f..",
"....####.......###.......####...",
"....####.......###.......####...",
"....####.......###.......####...",
"....c####......###......####c...",
".....####...............####....",
".....#####.............#####.f..",
"......#####...........#####.....",
"......c#####.........#####c.....",
".......#######g...g#######......",
".......f#################..f....",
".........c#############d........",
"...........###########..........",
"..........h..d#####c....h.......",
"................................",
"..............h.....h...........",
"................................"};

/*
 *  Constructs a interface as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 */
interface::interface( QWidget* parent, const char* name, WFlags fl )
    : QMainWindow( parent, name, fl ),
      image0( (const char **) image0_data ),
      image1( (const char **) image1_data ),
      image2( (const char **) image2_data ),
      image3( (const char **) image3_data ),
      image4( (const char **) image4_data ),
      image5( (const char **) image5_data ),
      image6( (const char **) image6_data ),
      image7( (const char **) image7_data ),
      image8( (const char **) image8_data )
{
    viewer = new Viewer(this, "viewer");
    viewer->setGeometry( QRect( 10, 10, 600, 595 ) );

    (void)statusBar();
    if ( !name )
	setName( "Interface Geometry Processing" );
    setCentralWidget( new QWidget( this, "qt_central_widget" ) );
    Form1Layout = new QHBoxLayout( centralWidget(), 11, 6, "Form1Layout"); 

    viewer = new Viewer( centralWidget(), "viewer" );
    Form1Layout->addWidget( viewer );

    // actions
    fileOpenAction = new QAction( this, "fileOpenAction" );
    fileOpenAction->setIconSet( QIconSet( image1 ) );
    fileSave_scene_asAction = new QAction( this, "fileSave_scene_asAction" );
    fileSave_scene_asAction->setIconSet( QIconSet( image0 ) );
    fileExitAction = new QAction( this, "fileExitAction" );
    fileExitAction->setIconSet( QIconSet( image8 ) );
    displayRepAction = new QAction( this, "displayRepAction" );
    displayEdgesAction = new QAction( this, "displayEdgesAction" );
    displaySmoothAction = new QAction( this, "displaySmoothAction" );
    displayInvertNormalsAction = new QAction( this, "displayInvertNormalsAction" );
    displayWorld_axisAction = new QAction( this, "displayWorld_axisAction" );
    displayXy_gridAction = new QAction( this, "displayXy_gridAction" );
    displayFull_screenAction = new QAction( this, "displayFull_screenAction" );
    displaySnapshotAction = new QAction( this, "displaySnapshotAction" );
    helpContentsAction = new QAction( this, "helpContentsAction" );
    helpAboutAction = new QAction( this, "helpAboutAction" );
    
    // menubar
    menubar = new QMenuBar( this, "menubar" );

    fileMenu = new QPopupMenu( this );
    fileOpenAction->addTo( fileMenu );
    fileSave_scene_asAction->addTo( fileMenu );
    fileMenu->insertSeparator();
    fileExitAction->addTo( fileMenu );
    menubar->insertItem( QString(""), fileMenu, 1 );

    displayMenu = new QPopupMenu( this );
    displayRepAction->addTo( displayMenu );
    displayEdgesAction->addTo( displayMenu );
    displaySmoothAction->addTo( displayMenu );
    displayInvertNormalsAction->addTo( displayMenu );
    displayMenu->insertSeparator();
    displayWorld_axisAction->addTo( displayMenu );
    displayXy_gridAction->addTo( displayMenu );
    displayMenu->insertSeparator();
    displayFull_screenAction->addTo( displayMenu );
    displaySnapshotAction->addTo( displayMenu );
    menubar->insertItem( QString(""), displayMenu, 2 );

    helpMenu = new QPopupMenu( this );
    helpContentsAction->addTo( helpMenu );
    helpAboutAction->addTo( helpMenu );
    menubar->insertItem( QString(""), helpMenu, 3 );
    
    languageChange();
    resize( QSize(800, 600).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( fileOpenAction, SIGNAL( activated() ), this, SLOT( fileOpen() ) );
    connect( fileSave_scene_asAction, SIGNAL( activated() ), this, SLOT( fileSave() ) );
    connect( fileExitAction, SIGNAL( activated() ), this, SLOT( close() ) );
    connect( displayRepAction, SIGNAL( activated() ), this, SLOT( toggleDisplayRep() ) );
    connect( displayEdgesAction, SIGNAL( activated() ), this, SLOT( toggleDrawEdges() ) );
    connect( displaySmoothAction, SIGNAL( activated() ), this, SLOT( toggleSmoothShading() ) );
    connect( displayInvertNormalsAction, SIGNAL( activated() ), this, SLOT( toggleInvertNormals() ) );
    connect( displayWorld_axisAction, SIGNAL( activated() ), viewer, SLOT( toggleAxisIsDrawn() ) );
    connect( displayXy_gridAction, SIGNAL( activated() ), viewer, SLOT( toggleGridIsDrawn() ) );
    connect( displayFull_screenAction, SIGNAL( activated() ), viewer, SLOT( toggleFullScreen() ) );
    connect( displaySnapshotAction, SIGNAL( activated() ), viewer, SLOT( saveSnapshot() ) );
    connect( helpContentsAction, SIGNAL( activated() ), viewer, SLOT( help() ) );
    connect( helpAboutAction, SIGNAL( activated() ), viewer, SLOT( aboutQGLViewer() ) );
    
    strcpy(current_filename,"");

}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void interface::languageChange()
{
    setCaption( tr( "Interface Geometry Processing" ) );
    fileOpenAction->setText( tr( "Open" ) );
    fileOpenAction->setMenuText( tr( "Open..." ) );
    fileOpenAction->setAccel( QKeySequence( tr( "Ctrl+O" ) ) );
    fileSave_scene_asAction->setText( tr( "Save scene as" ) );
    fileSave_scene_asAction->setMenuText( tr( "Save scene as..." ) );
    fileSave_scene_asAction->setAccel( QKeySequence( tr( "Ctrl+S" ) ) );
    fileExitAction->setText( tr( "Exit" ) );
    fileExitAction->setMenuText( tr( "Exit" ) );
    fileExitAction->setAccel( QKeySequence( tr( "Esc" ) ) );
    displayRepAction->setText( tr( "Wireframe/points/surface" ) );
    displayRepAction->setMenuText( tr( "Wireframe/points/surface" ) );
    displayRepAction->setAccel( QKeySequence( tr( "R" ) ) );
    displayEdgesAction->setText( tr( "Edges" ) );
    displayEdgesAction->setMenuText( tr( "Edges" ) );
    displayEdgesAction->setAccel( QKeySequence( tr( "E" ) ) );
    displaySmoothAction->setText( tr( "Smooth shading" ) );
    displaySmoothAction->setMenuText( tr( "Smooth shading" ) );
    displaySmoothAction->setAccel( QKeySequence( tr( "X" ) ) );
    displayInvertNormalsAction->setText( tr( "Invert normals" ) );
    displayInvertNormalsAction->setMenuText( tr( "Invert Normals" ) );
    displayInvertNormalsAction->setAccel( QKeySequence( tr( "N" ) ) );
    displayWorld_axisAction->setText( tr( "World axis" ) );
    displayWorld_axisAction->setMenuText( tr( "World axis" ) );
    displayWorld_axisAction->setAccel( QKeySequence( tr( "A" ) ) );
    displayXy_gridAction->setText( tr( "XY grid" ) );
    displayXy_gridAction->setMenuText( tr( "XY grid" ) );
    displayXy_gridAction->setAccel( QKeySequence( tr( "G" ) ) );
    displayFull_screenAction->setText( tr( "Full screen" ) );
    displayFull_screenAction->setMenuText( tr( "Full screen" ) );
    displayFull_screenAction->setAccel( QKeySequence( tr( "Alt+Return" ) ) );
    displaySnapshotAction->setText( tr( "Snapshot" ) );
    displaySnapshotAction->setMenuText( tr( "Snapshot" ) );
    displaySnapshotAction->setAccel( QKeySequence( tr( "Return" ) ) );
    helpContentsAction->setText( tr( "Contents" ) );
    helpContentsAction->setMenuText( tr( "Contents..." ) );
    helpContentsAction->setAccel( QKeySequence( tr( "H" ) ) );
    helpAboutAction->setText( tr( "About" ) );
    helpAboutAction->setMenuText( tr( "About..." ) );
    
    if (menubar->findItem(1))
        menubar->findItem(1)->setText( tr( "File" ) );
    if (menubar->findItem(2))
        menubar->findItem(2)->setText( tr( "Display" ) );
    if (menubar->findItem(3))
        menubar->findItem(3)->setText( tr( "Help" ) );
}

void interface::fileOpen()
{
    QFileDialog* fd = new QFileDialog( this, "file dialog", TRUE );
    const QString path= ""; // A COMPLETER : entrez ici le chemin d'accs
    			    // au rpertoire o vous stockez vos donnes

    fd->setDir(path);
    fd->setMode( QFileDialog::ExistingFile);
    fd->setFilter( "Mesh (*.off)" );

    QString fileName;
    if ( fd->exec() == QDialog::Accepted )
        {
        fileName = fd->selectedFile();
        viewer->changeMesh((const char*) fileName);
        QFileInfo fi( fileName);
        }
    setCaption( tr( fileName ) );
  
    strcpy(current_filename,fileName);  
};

void interface::fileSave()
{
	// Pop up the standard modal file browser dialog.
	QStringList filenames = QFileDialog::getSaveFileName (
	  QString::null, // no pre-set working directory
	  "Mesh (*.off)",
	  this, // dialog's parent
	  NULL, // no internal name for the dialog
	  "Save file as..."
	);

	// Bail if the user cancels or doesn't enter a file name.
	QString filename = filenames.front();
	if (filename == QString::null)
	{
		return;
	}
	
	// Try to open the file for writing.	
	QFile outfile (filename);
	if (!outfile.open (IO_WriteOnly))
	{
		QMessageBox::information (this, "File open error",
		  "Could not open the file " + filename + " for writing."
		);
		return;
	}

	viewer->saveMesh(filename);
	strcpy(current_filename,filename);
	
}

void interface::toggleDrawEdges()
{
	viewer->toggleDrawEdges();
};

void interface::toggleInvertNormals()
{
	viewer->toggleInvertNormals();
};

void interface::toggleDisplayRep()
{
	viewer->toggleDisplayRep();
};

void interface::toggleSmoothShading()
{
	viewer->toggleSmoothShading();
};
  
