#ifndef INTERFACE_H
#define INTERFACE_H

#include <qmainwindow.h>
#include <qpixmap.h>
#include "viewer.h"

#define MAX_FILE_NAME_LENGTH 256

class QAction;
class QPopupMenu;

class interface : public QMainWindow
{
    Q_OBJECT

public:
    interface( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~interface(){};

    Viewer*      viewer;
    QMenuBar *menubar;
    QPopupMenu *fileMenu;
    QPopupMenu *displayMenu;
    QPopupMenu *helpMenu;
    
    QAction* fileOpenAction;
    QAction* fileSave_scene_asAction;
    QAction* fileExitAction;
    QAction* displayRepAction;
    QAction* displayEdgesAction;
    QAction* displaySmoothAction;
    QAction* displayInvertNormalsAction;
    QAction* displayWorld_axisAction;
    QAction* displayXy_gridAction;
    QAction* displayFull_screenAction;
    QAction* displaySnapshotAction;
    QAction* helpContentsAction;
    QAction* helpAboutAction;

public slots:
    virtual void fileOpen();
    virtual void fileSave();
    virtual void toggleDrawEdges();
    virtual void toggleDisplayRep();
    virtual void toggleSmoothShading();
    virtual void toggleInvertNormals();
    
protected:
    QHBoxLayout* Form1Layout;

protected slots:
    virtual void languageChange();

private:
    QPixmap image0;
    QPixmap image1;
    QPixmap image2;
    QPixmap image3;
    QPixmap image4;
    QPixmap image5;
    QPixmap image6;
    QPixmap image7;
    QPixmap image8;
    char current_filename[MAX_FILE_NAME_LENGTH];
    
};

#endif // INTERFACE_H
