#ifndef VIEWER_H
#define VIEWER_H

#include <QGLViewer/qglviewer.h>

// OpenMesh
#include <OpenMesh/Core/IO/MeshIO.hh>
#include <OpenMesh/Core/Mesh/PolyMesh_ArrayKernelT.hh>

// Maillage = maillage OpenMesh
// Attribut supplmentaire : normales aux sommets et aux faces
/*struct MyTraits : public OpenMesh::DefaultTraits
{
	VertexAttributes( OpenMesh::Attributes::Normal );
	
	FaceAttributes( OpenMesh::Attributes::Normal );
};

typedef OpenMesh::TriMesh_ArrayKernelT<MyTraits> MyMesh;*/
typedef OpenMesh::PolyMesh_ArrayKernelT<> MyMesh;

class Viewer : public QGLViewer
{
public:
  Viewer(QWidget *parent,const char *name);
  ~Viewer() { }
  
  void changeMesh(const char*);
  void saveMesh(const char*);
  void toggleDrawEdges();
  void toggleInvertNormals();
  void toggleDisplayRep();
  void toggleSmoothShading();
  
  // Different display modes
  enum DisplayMode { SURF, WIRE, PTS };
  DisplayMode displayMode_;
  
  DisplayMode dispMode() const;
  void dispMode(DisplayMode);
   	
protected:

  MyMesh m;
  
  bool drawMesh_;
  bool drawEdges_;
  bool invertNormals_;
  bool smooth_;
	
  // Drawing procedure
  virtual void draw();
  
  // Other procedures
  virtual void init();
  virtual QString helpString() const;  

};

#endif
